#version 120

varying vec2 uv;

uniform sampler2D tex;
uniform vec4 Misc;
uniform vec4 Color;

const float PI = 3.14159f;

void main(void)
{
	float time = Misc.x;		// current time
	float timeOffset = Misc.y;	// if multiple auroras, have time offset
	float direction = Misc.z;	// direction that the effect is fading
	float alpha_fade = Misc.w;
	
	vec4 perlinTex =  texture2D(tex, vec2(uv.x, time*0.00003f+timeOffset) );
	float height = perlinTex.x;
	
	float alphaBuffer = 0.15f;
	float alpha = smoothstep(0.0f, height*(1.0f-alphaBuffer), uv.y );
	alpha *= (1.0f-smoothstep( height*(1.0f-alphaBuffer*1.5f), height, uv.y ));
	alpha *= smoothstep(0.0f, alphaBuffer, uv.x);
	alpha *= 1.0f-smoothstep(1.0f-alphaBuffer, 1.0f, uv.x);
	alpha *= mix( alpha_fade, 1.0f, sin( PI*2.0f*(uv.x+timeOffset)+direction*time*0.0009f)*0.5f+0.5f);
	
	vec3 auroraColor = Color.xyz;
	gl_FragColor = vec4(auroraColor, alpha*Color.w );
	
	//if ( height < uv.y ) discard;
}