#version 120

uniform sampler2D texRaw;
uniform sampler2D texBloom;
uniform sampler2D texDistort;
uniform vec4 bloomData;
uniform vec4 stepSize;

void main(void)
{
	vec2 uv = gl_TexCoord[0].xy;	
	
	vec4 distort =  texture2D(texDistort, uv);
	vec2 distortUV = (distort.xy * 2.0f - vec2(1.0f)) * distort.z;
	vec2 distortAmmount = vec2( distortUV.x * stepSize.x, distortUV.y * stepSize.y );
	
	float distortCoeff = 22.0f;
	vec3 diffuse = texture2D(texRaw, uv + distortAmmount*distortCoeff).xyz;
	vec3 bloom =  texture2D(texBloom, uv).xyz;
	
	float bloomCoeff = bloomData.x;
	vec3 bloomPower = vec3(bloomData.y, bloomData.y, bloomData.y);
	bloom = pow(bloom,bloomPower) * bloomCoeff;

	// calc vignette
	float vignette = clamp( 1.4f-length( uv*2.0f-vec2(1.0f) ), 0.0f, 1.0f );
	vignette =  mix( 1.0f-bloomData.z, 1.0f, vignette);

	gl_FragColor = vec4( vignette*( (vec3(1.0f)-bloom)*diffuse + bloom), 1.0f );
}