#version 120

varying vec2 uv;

uniform sampler2D tex;
uniform vec4 Color;
uniform vec4 Misc;

const float PI = 3.14159f;

void main(void)
{
	float offset = Misc.x;
	float time = Misc.y;
	float perlinVal =  texture2D(tex, vec2(uv.x*0.7f+offset, 0.1f*time) ).x;
	
	float alpha = smoothstep( 0.0f, Misc.z, 1.0f-abs(uv.x*2.0f-1.0f));
	alpha *= smoothstep( 0.0f, Misc.w, uv.y);
	
	vec4 color = Color;
	color.w *= alpha*pow(perlinVal,2.0f);
	gl_FragColor = color;
}