#version 120

varying vec2 uv;

uniform sampler2D tex;
uniform vec4 Misc;

void main(void)
{
	vec2 uvNorm = uv * 2.0f - vec2(1.0f);
	float uvNormLen = length(uvNorm);
	float alpha = smoothstep( 0.0f, 0.05f, 1.0f-uvNormLen );
	
	vec3 diffuse = texture2D(tex, uv).xyz;
	
	float time = Misc.w;
	vec2 uvSample = uv + vec2(time*0.2f) + (diffuse.xy*2.0f-1.0f)*0.2f;
	vec3 diffuseNew = texture2D(tex, uvSample*0.6f).xyz;
	
	vec3 finalColor = mix( 
		vec3( pow(diffuseNew.x, 0.9f) ),
		 Misc.xyz, 
		smoothstep( 0.6f, 1.0f, uvNormLen ) 
		);
		
	gl_FragColor = vec4(finalColor.xyz, alpha);
	
}