#version 120

uniform sampler2D tex;
uniform sampler2D texWater;
uniform sampler2D texRipple;
uniform vec4 waterData;

void main(void)
{
	float time = waterData.x;
	float invWaterCoeff = waterData.y;
	
	vec2 uv = gl_TexCoord[0].xy;	
	vec2 screenPos = gl_TexCoord[1].xy * 0.5f + vec2(0.5f);
	
	vec2 waterRippleUV = vec2(screenPos.x, screenPos.y*invWaterCoeff);
	float waterRipple = texture2D(texRipple, waterRippleUV).w;

	vec3 waterNormal =  texture2D(texWater, uv + vec2(waterRipple*0.1,-0.00003f*time)).xyz;
	vec2 waterNorm2d = normalize( waterNormal.xy )*2.0f-vec2(1.0f);
	
	

	// offset based on water tex
	vec2 uvOffset = mix( 
		vec2(0.0f), 
		sin(time*0.002f +waterNormal.x*10.0f + waterNormal.y )*0.1f + waterNorm2d*0.5f,
		smoothstep( 0.0f, 0.65f, pow(uv.y-0.2, 1.0f)));
		//pow(uv.y,3.0ff));
	uvOffset.y = clamp( uvOffset.y, 0.0f, 1.0f );

	vec3 diffuse =  texture2D(tex, uv+uvOffset).xyz;

	gl_FragColor = vec4( diffuse + vec3(waterRipple*0.045f), 1.0f );
	//gl_FragColor = vec4( screenPos, 0.0f, 1.0f );
	//gl_FragColor = vec4( vec3(waterRipple), 1.0f );
}