#version 120

uniform sampler2D	prevTex;
uniform sampler2D	currTex;
uniform vec4		Misc;

void main(void)
{
	vec2 uv = gl_TexCoord[0].xy;	
	vec2 screenPos = gl_TexCoord[1].xy * 0.5f + vec2(0.5f);
	vec2 stepUV = Misc.xy;

	float currVal =  texture2D(currTex, uv).w;
	
	
	// previous
	//float prevVal =  texture2D(prevTex, uv).w;
	float left	= texture2D(prevTex, uv-vec2(stepUV.x, 0.0f)).w;
	float right = texture2D(prevTex, uv+vec2(stepUV.x, 0.0f)).w;
	float top	= texture2D(prevTex, uv-vec2(0.0f, stepUV.y*0.5f)).w;
	float bot	= texture2D(prevTex, uv+vec2(0.0f, stepUV.y*0.5f)).w;
	
	float damping = mix(1.0f, 0.9f, uv.y );
	
	float smoothedVal = (left+right+top+bot)*0.5f-currVal;
	smoothedVal *= damping;

	gl_FragColor = vec4( smoothedVal );
}