#version 120

uniform vec4 camPos;

varying vec3 worldPos;
varying vec3 normal;
varying vec3 vertToLight;

void main(void)
{
	vec3 vecToCam = normalize( camPos.xyz - worldPos.xyz );
	vec3 normalizedNormal = normalize(normal);
	vec3 vertToLightNormal = normalize(vertToLight);
	
	float fresnel =  pow( cos( dot(vecToCam, normalizedNormal )), 20.0f  );
	
	vec3 terrain_dark = vec3(0)/255.0f;
	vec3 terrain_light= vec3( 255.0f, 6.0f, 30.0f )/255.0f;
	vec3 terrain_color = mix( terrain_dark, terrain_light, fresnel );
	
	float shade = pow(dot( normalizedNormal, vertToLightNormal), 5.0f);
	
	//gl_FragColor = vec4( normalizedNormal.x, normalizedNormal.y, normalizedNormal.z, 1.0f );
	//gl_FragColor = vec4( normalizedNormal, 1.0f );
	gl_FragColor = vec4( terrain_color, 1.0f);
}